diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index db97cf0ad..0ada25eff 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
@@ -42,7 +41,7 @@ public class ItemPebble extends Item implements IDispensable
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-        if (id != Blocks.OVERLAY_PEBBLES.id && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+        if (id != Blocks.OVERLAY_PEBBLES.id() && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
         {
             id = 0;
             meta = 0;
@@ -51,13 +50,13 @@ public class ItemPebble extends Item implements IDispensable
         {
             return false;
         }
-        if (blockY == world.getHeightBlocks() - 1 && Blocks.OVERLAY_PEBBLES.blockMaterial.isSolid())
+        if (blockY == world.getHeightBlocks() - 1 && Blocks.OVERLAY_PEBBLES.getMaterial().isSolid())
         {
             return false;
         }
 
         // Check if we're placing "inside" a layer
-        if (id == Blocks.OVERLAY_PEBBLES.id && side == Side.TOP)
+        if (id == Blocks.OVERLAY_PEBBLES.id() && side == Side.TOP)
         {
 
             final int newMeta = meta + 1;
@@ -68,7 +67,7 @@ public class ItemPebble extends Item implements IDispensable
 
             if (newMeta < 3)
             {
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, newMeta);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id(), newMeta);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
                 return true;
@@ -88,7 +87,7 @@ public class ItemPebble extends Item implements IDispensable
         }
 
         // Check if the block we're placing into is a layer
-        if (id == Blocks.OVERLAY_PEBBLES.id)
+        if (id == Blocks.OVERLAY_PEBBLES.id())
         {
             final int newMeta = meta + 1;
 
@@ -100,7 +99,7 @@ public class ItemPebble extends Item implements IDispensable
 
             if (newMeta < 3)
             {
-                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, newMeta);
+                world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id(), newMeta);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
                 return true;
@@ -109,9 +108,9 @@ public class ItemPebble extends Item implements IDispensable
         }
 
         // Regular placement, as all else fails
-        if (world.canBlockBePlacedAt(Blocks.OVERLAY_PEBBLES.id, blockX, blockY, blockZ, false, side) && world.isBlockOpaqueCube(blockX, blockY - 1, blockZ))
+        if (world.canBlockBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockX, blockY, blockZ, false, side) && world.isBlockOpaqueCube(blockX, blockY - 1, blockZ))
         {
-            if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id, 0))
+            if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.OVERLAY_PEBBLES.id(), 0))
             {
                 Blocks.OVERLAY_PEBBLES.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index 9ca22a495..2f08bbaa2 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -14,9 +14,9 @@ import java.util.Random;
 
 public class ItemPlaceable extends Item {
 	
-	public Block blockToPlace;
+	public Block<?> blockToPlace;
 	
-	public ItemPlaceable(String name, String namespaceId, int id, Block blockToPlace) {
+	public ItemPlaceable(String name, String namespaceId, int id, Block<?> blockToPlace) {
 		super(name, namespaceId, id);
 		
 		this.blockToPlace = blockToPlace;
@@ -36,8 +36,8 @@ public class ItemPlaceable extends Item {
 		if(blockY < 0 || blockY >= world.getHeightBlocks()) {
 			return false;
 		}
-		if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
-			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id)) {
+		if(world.canBlockBePlacedAt(blockToPlace.id(), blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
+			if(world.setBlockWithNotify(blockX, blockY, blockZ, blockToPlace.id())) {
 				if (player == null) {
 					blockToPlace.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
@@ -55,7 +55,7 @@ public class ItemPlaceable extends Item {
 		int x = blockX + direction.getOffsetX();
 		int y = blockY + direction.getOffsetY();
 		int z = blockZ + direction.getOffsetZ();
-		Block b = world.getBlock(x, y, z);
+		Block<?> b = world.getBlock(x, y, z);
 		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
 			onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
index 0cb154f31..bf6d2d424 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRope;
+import net.minecraft.core.block.BlockLogicRope;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
@@ -9,7 +9,7 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemRope extends ItemPlaceable {
-    public ItemRope(String name, String namespaceId, int id, Block blockToPlace) {
+    public ItemRope(String name, String namespaceId, int id, Block<?> blockToPlace) {
         super(name, namespaceId, id, blockToPlace);
     }
     @Override
@@ -23,7 +23,7 @@ public class ItemRope extends ItemPlaceable {
             int _y = blockY;
             while (_y > 0){
                 _y--;
-                if (world.canBlockBePlacedAt(blockToPlace.id, blockX, _y, blockZ, false, side)){
+                if (world.canBlockBePlacedAt(blockToPlace.id(), blockX, _y, blockZ, false, side)){
                     blockY = _y;
                     break;
                 } else if (world.getBlock(blockX, _y, blockZ) != blockToPlace) {
@@ -43,8 +43,8 @@ public class ItemRope extends ItemPlaceable {
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
             return false;
         }
-        if(world.canBlockBePlacedAt(blockToPlace.id, blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
-            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id, placeOnSide ? BlockRope.MASK_ROPE_CONNECT : 0)) {
+        if(world.canBlockBePlacedAt(blockToPlace.id(), blockX, blockY, blockZ, false, side) && stack.consumeItem(player)) {
+            if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockToPlace.id(), placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
                 if (player == null) {
                     blockToPlace.onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
                 } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java b/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
index ecb9f337a..58b40e401 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSaddle.java
@@ -14,11 +14,11 @@ public class ItemSaddle extends Item
     }
 
     @Override
-    public boolean useItemOnEntity(ItemStack itemstack, Mob entityliving, Player entityPlayer)
+    public boolean useItemOnEntity(ItemStack itemstack, Mob mob, Player player)
     {
-        if(entityliving instanceof MobPig && itemstack.consumeItem(entityPlayer))
+        if(mob instanceof MobPig && itemstack.consumeItem(player))
         {
-            MobPig entitypig = (MobPig)entityliving;
+            MobPig entitypig = (MobPig) mob;
             if(!entitypig.getSaddled())
             {
                 entitypig.setSaddled(true);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
index b40949425..2d85a85ca 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -14,11 +14,11 @@ import net.minecraft.core.world.World;
 import java.util.Random;
 
 public class ItemSeeds extends Item {
-	private int cropsId;
+	private final Block<?> cropsBlock;
 
-	public ItemSeeds(String name, String namespaceId, int id, Block cropsBlock) {
+	public ItemSeeds(String name, String namespaceId, int id, Block<?> cropsBlock) {
 		super(name, namespaceId, id);
-		cropsId = cropsBlock.id;
+		this.cropsBlock = cropsBlock;
 	}
 
 	@Override
@@ -28,9 +28,9 @@ public class ItemSeeds extends Item {
 			blockY += side.getOffsetY();
 			blockZ += side.getOffsetZ();
 		}
-		if(world.getBlockId(blockX, blockY - 1, blockZ) == Blocks.FARMLAND_DIRT.id && world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
-			if(world.setBlockWithNotify(blockX, blockY, blockZ, cropsId)) {
-				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.blocksList[cropsId], EnumBlockSoundEffectType.PLACE);
+		if(world.getBlockId(blockX, blockY - 1, blockZ) == Blocks.FARMLAND_DIRT.id() && world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
+			if(world.setBlockWithNotify(blockX, blockY, blockZ, cropsBlock.id())) {
+				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, cropsBlock, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
 				return true;
 			}
@@ -42,7 +42,7 @@ public class ItemSeeds extends Item {
 		int x = blockX + direction.getOffsetX();
 		int y = blockY + direction.getOffsetY();
 		int z = blockZ + direction.getOffsetZ();
-		Block b = world.getBlock(x, y, z);
+		Block<?> b = world.getBlock(x, y, z);
 		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
 			onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index b9283d055..d092dd03b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -45,11 +45,11 @@ public class ItemSign extends Item
         if(sideHit == 1)
         {
             world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.SIGN_POST_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_POST_PLANKS_OAK.id, MathHelper.floor((double)(((entityplayer.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_POST_PLANKS_OAK.id(), MathHelper.floor((double)(((entityplayer.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         } else
         {
             world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_WALL_PLANKS_OAK.id, sideHit);
+            world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.SIGN_WALL_PLANKS_OAK.id(), sideHit);
         }
         itemstack.consumeItem(entityplayer);
         TileEntitySign tileentitysign = (TileEntitySign)world.getBlockEntity(blockX, blockY, blockZ);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index f62dbcf25..b341462d1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -42,24 +42,24 @@ public final class ItemStack {
         this(item.asItem(), stackSize, metadata);
     }
 
-    public ItemStack(Block block)
+    public ItemStack(Block<?> block)
     {
         this(block, 1);
     }
 
-    public ItemStack(Block block, int stackSize)
+    public ItemStack(Block<?> block, int stackSize)
     {
-        this(block.id, stackSize, 0);
+        this(block.id(), stackSize, 0);
     }
 
-    public ItemStack(Block block, int stackSize, int metadata)
+    public ItemStack(Block<?> block, int stackSize, int metadata)
     {
-        this(block.id, stackSize, metadata);
+        this(block.id(), stackSize, metadata);
     }
 
-    public ItemStack(Block block, int stackSize, int metadata, @Nullable CompoundTag tag)
+    public ItemStack(Block<?> block, int stackSize, int metadata, @Nullable CompoundTag tag)
     {
-        this(block.id, stackSize, metadata, tag);
+        this(block.id(), stackSize, metadata, tag);
     }
 
     public ItemStack(Item item)
@@ -92,6 +92,7 @@ public final class ItemStack {
         this.metadata = itemStack.metadata;
         this.stackSize = itemStack.stackSize;
         this.tag = new CompoundTag(itemStack.tag);
+        this.animationsToGo = 0;
     }
 
     public ItemStack(int itemID, int stackSize, int metadata, @Nullable CompoundTag tag)
@@ -131,7 +132,7 @@ public final class ItemStack {
         return flag;
     }
 
-    public float getStrVsBlock(Block block)
+    public float getStrVsBlock(Block<?> block)
     {
         return getItem().getStrVsBlock(this, block);
     }
@@ -200,8 +201,8 @@ public final class ItemStack {
 			itemID = 0;
 		}
 		
-		if(itemID == Blocks.CHEST_LEGACY.id) itemID = Blocks.CHEST_PLANKS_OAK.id;
-		if(itemID == Blocks.CHEST_LEGACY_PAINTED.id) itemID = Blocks.CHEST_PLANKS_OAK_PAINTED.id;
+		if(itemID == Blocks.CHEST_LEGACY.id()) itemID = Blocks.CHEST_PLANKS_OAK.id();
+		if(itemID == Blocks.CHEST_LEGACY_PAINTED.id()) itemID = Blocks.CHEST_PLANKS_OAK_PAINTED.id();
 	}
 
     public int getMaxStackSize()
@@ -291,12 +292,12 @@ public final class ItemStack {
         metadata -= i;
     }
 
-    public void hitEntity(Mob entityliving, Player entityplayer)
+    public void hitEntity(Mob target, Player attacker)
     {
-        boolean flag = Item.itemsList[itemID].hitEntity(this, entityliving, entityplayer);
+        boolean flag = Item.itemsList[itemID].hitEntity(this, target, attacker);
         if(flag)
         {
-            entityplayer.addStat(getItem().getStat(StatList.STAT_USED), 1);
+            attacker.addStat(getItem().getStat(StatList.STAT_USED), 1);
         }
     }
     
@@ -328,14 +329,14 @@ public final class ItemStack {
         return Item.itemsList[itemID].getDamageVsEntity(entity);
     }
 
-    public boolean canHarvestBlock(Mob entityLiving, Block block)
+    public boolean canHarvestBlock(Mob mob, Block<?> block)
     {
-        return Item.itemsList[itemID].canHarvestBlock(entityLiving, this, block);
+        return Item.itemsList[itemID].canHarvestBlock(mob, this, block);
     }
 
-    public boolean useItemOnEntity(Mob entityliving, Player entityPlayer)
+    public boolean useItemOnEntity(Mob mob, Player entityPlayer)
     {
-        return Item.itemsList[itemID].useItemOnEntity(this, entityliving, entityPlayer);
+        return Item.itemsList[itemID].useItemOnEntity(this, mob, entityPlayer);
     }
 
     public ItemStack copy()
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index e4a528f69..aa7b83735 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -2,7 +2,6 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.item.material.ArmorMaterial;
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index fec0178f8..f9921b073 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -11,25 +11,27 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Objects;
 import java.util.Random;
 
-public class ItemBlock extends Item
+public class ItemBlock<T extends BlockLogic> extends Item
 {
 
-    protected int blockID;
+    protected @NotNull Block<T> block;
 
-    public ItemBlock(Block block)
+    public ItemBlock(@NotNull Block<T> block)
     {
-        super(block.namespaceID, block.id);
-        blockID = block.id;
+        super(block.namespaceId(), block.id());
+        this.block = Objects.requireNonNull(block);
         setKey(block.getKey());
     }
 
-    public Block getBlock()
+    public @NotNull Block<T> getBlock()
     {
-        return Blocks.blocksList[blockID];
+        return block;
     }
 
     @Override
@@ -45,10 +47,9 @@ public class ItemBlock extends Item
 		if(y < 0 || y >= world.getHeightBlocks()) {
 			return false;
 		}
-		if(world.canBlockBePlacedAt(blockID, x, y, z, false, side)) {
-			Block block = Blocks.blocksList[blockID];
+		if(world.canBlockBePlacedAt(block.id(), x, y, z, false, side)) {
 			int meta = getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
-			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
+			if(world.setBlockAndMetadataWithNotify(x, y, z, block.id(), meta)) {
 				stack.consumeItem(player);
 				if (player == null) {
                     block.onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
@@ -67,7 +68,7 @@ public class ItemBlock extends Item
         int x = blockX + direction.getOffsetX();
         int y = blockY + direction.getOffsetY();
         int z = blockZ + direction.getOffsetZ();
-        Block b = world.getBlock(x, y, z);
+        Block<?> b = world.getBlock(x, y, z);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
             onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
         }
@@ -75,18 +76,18 @@ public class ItemBlock extends Item
 
     public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
     {
-    	return Blocks.getBlock(blockID).getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
+    	return block.getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
     }
 
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
-        return Blocks.blocksList[blockID].getLanguageKey(itemstack.getMetadata());
+        return block.getLanguageKey(itemstack.getMetadata());
     }
 
     @Override
     public String getKey()
     {
-        return Blocks.blocksList[blockID].getKey();
+        return block.getKey();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index cf75bd63c..4c855eb14 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -1,26 +1,25 @@
 package net.minecraft.core.item.block;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class ItemBlockAlgae extends ItemBlock
+public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T>
 {
 
-    public ItemBlockAlgae(Block block)
+    public ItemBlockAlgae(Block<T> block)
     {
         super(block);
         setMaxDamage(0);
@@ -36,34 +35,19 @@ public class ItemBlockAlgae extends ItemBlock
     @Override
     public ItemStack onUseItem(ItemStack itemstack, World world, Player player)
     {
-        float f = 1.0F;
-        float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
-        float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
-        double d = player.xo + (player.x - player.xo) * (double)f;
-        double d1 = (player.yo + (player.y - player.yo) * (double)f + 1.62D) - (double)player.heightOffset;
-        double d2 = player.zo + (player.z - player.zo) * (double)f;
-        Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
-        float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
-        float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
-        float f5 = -MathHelper.cos(-f1 * 0.01745329F);
-        float f6 = MathHelper.sin(-f1 * 0.01745329F);
-        float f7 = f4 * f5;
-        float f8 = f6;
-        float f9 = f3 * f5;
-        double d3 = 5D;
-        Vec3 vec31 = vec3.add((double)f7 * d3, (double)f8 * d3, (double)f9 * d3);
-        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3, vec31, true);
-        if(movingobjectposition == null)
+        double reachDistance = player.getGamemode().getBlockReachDistance();
+        HitResult rayTraceResult = player.rayTrace(reachDistance, 1f, true, false);
+        if(rayTraceResult == null)
         {
             return itemstack;
         }
-        if(movingobjectposition.hitType == HitResult.HitType.TILE)
+        if(rayTraceResult.hitType == HitResult.HitType.TILE)
         {
-            int blockX = movingobjectposition.x;
-            int blockY = movingobjectposition.y;
-            int blockZ = movingobjectposition.z;
+            int blockX = rayTraceResult.x;
+            int blockY = rayTraceResult.y;
+            int blockZ = rayTraceResult.z;
 
-            if(world.getBlockId(blockX, blockY, blockZ) == Blocks.FLUID_WATER_STILL.id)
+            if(world.getBlockId(blockX, blockY, blockZ) == Blocks.FLUID_WATER_STILL.id())
             {
                 blockY++;
             }
@@ -73,10 +57,9 @@ public class ItemBlockAlgae extends ItemBlock
 
             if(world.getBlockId(blockX, blockY, blockZ) != 0)
                 return itemstack;
-            Block block = Blocks.blocksList[Blocks.ALGAE.id];
-            if(itemstack.consumeItem(player) && world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.ALGAE.id, 0))
+            if(itemstack.consumeItem(player) && world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, block.id(), 0))
             {
-                Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.5, 0.5);
+                block.onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.5, 0.5);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 player.swingItem();
             }
@@ -90,11 +73,11 @@ public class ItemBlockAlgae extends ItemBlock
         int x = blockX + direction.getOffsetX();
         int y = blockY + direction.getOffsetY();
         int z = blockZ + direction.getOffsetZ();
-        Block b = world.getBlock(x, y, z);
-        Block bAbove = world.getBlock(x, y + 1, z);
+        Block<?> b = world.getBlock(x, y, z);
+        Block<?> bAbove = world.getBlock(x, y + 1, z);
         if (b == Blocks.FLUID_WATER_STILL && (bAbove == null || bAbove.hasTag(BlockTags.PLACE_OVERWRITES))) {
-            world.setBlockWithNotify(x, y + 1, z, Blocks.ALGAE.id);
-            Blocks.ALGAE.onBlockPlacedOnSide(world, x, y + 1, z, Side.NONE, 0.5, 0.5);
+            world.setBlockWithNotify(x, y + 1, z, block.id());
+            block.onBlockPlacedOnSide(world, x, y + 1, z, Side.NONE, 0.5, 0.5);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index f9920881b..d874c0e49 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -1,8 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLadder;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BlockLogicLadder;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
@@ -10,25 +9,23 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemBlockLadder extends ItemBlock {
+public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
 
-	private BlockLadder ladderBlock;
-	
-	public ItemBlockLadder(BlockLadder block) {
+	public ItemBlockLadder(Block<T> block) {
 		super(block);
-		
-		this.ladderBlock = block;
 	}
 	
 	@Override
 	public boolean onUseItemOnBlock(ItemStack stack, @Nullable Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
-		Block clickedBlock = world.getBlock(x, y, z);
-		
-		if(clickedBlock == ladderBlock && player != null && !player.isSneaking()) {
-			Side clickedLadderSide = ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z));
-			while(world.getBlock(x, y, z) == ladderBlock && ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z)) == clickedLadderSide) y--;
-			int meta = ladderBlock.getMetaForSide(clickedLadderSide);
-			if(ladderBlock.canExistAt(world, x, y, z, meta)) {
+		Block<?> clickedBlock = world.getBlock(x, y, z);
+
+		BlockLogicLadder ladder = block.getLogic();
+
+		if(clickedBlock == block && player != null && !player.isSneaking()) {
+			Side clickedLadderSide = ladder.getSideFromMeta(world.getBlockMetadata(x, y, z));
+			while(world.getBlock(x, y, z) == block && ladder.getSideFromMeta(world.getBlockMetadata(x, y, z)) == clickedLadderSide) y--;
+			int meta = ladder.getMetaForSide(clickedLadderSide);
+			if(ladder.canExistAt(world, x, y, z, meta)) {
 				return placeBlock(world, x, y, z, meta, player, stack, clickedLadderSide, 0.5, 0.5);
 			}
 			
@@ -41,13 +38,13 @@ public class ItemBlockLadder extends ItemBlock {
 			z += side.getOffsetZ();
 		}
 		
-		Side sideForPlacement = ladderBlock.getSideForPlacement(world, x, y, z, side);
+		Side sideForPlacement = ladder.getSideForPlacement(world, x, y, z, side);
 		if(sideForPlacement == null) {
 			return false;
 		}
 		
-		int meta = ladderBlock.getMetaForSide(sideForPlacement);
-		if(ladderBlock.canExistAt(world, x, y, z, meta)) {
+		int meta = ladder.getMetaForSide(sideForPlacement);
+		if(ladder.canExistAt(world, x, y, z, meta)) {
 			return placeBlock(world, x, y, z, meta, player, stack, sideForPlacement, xPlaced, yPlaced);
 		}
 		
@@ -55,10 +52,10 @@ public class ItemBlockLadder extends ItemBlock {
 	}
 	
 	public boolean placeBlock(World world, int x, int y, int z, int meta, @Nullable Player player, ItemStack stack, Side side, double xPlaced, double yPlaced) {
-		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
-			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
-				Blocks.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, xPlaced, yPlaced);
-				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, ladderBlock, EnumBlockSoundEffectType.PLACE);
+		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(block.id(), x, y, z, false, side) && stack.consumeItem(player)) {
+			if(world.setBlockAndMetadataWithNotify(x, y, z, block.id(), meta)) {
+				block.onBlockPlacedByMob(world, x, y, z, side, player, xPlaced, yPlaced);
+				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.PLACE);
 				return true;
 			}
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
index 4414c2bb8..f51eca773 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
@@ -8,10 +9,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemBlockLamp extends ItemBlock
+public class ItemBlockLamp<T extends BlockLogic> extends ItemBlock<T>
 {
 
-    public ItemBlockLamp(Block block)
+    public ItemBlockLamp(Block<T> block)
     {
         super(block);
         setMaxDamage(0);
